{*******************************************************************************
  HiAsm stamp component builder v0.8 (autor - andrestudio <andrestudio@list.ru>)
  Component - DSGrabber
  Version - 1.0
  Autor - andrestudio
  E-mail - andrestudio72@yandex.ru
  Create - , 17.  2016, 16:15:16
  Description:     
*******************************************************************************}

unit hiDSGrabber;

interface

uses
  Windows,Kol,Share,Debug,dshow,ActiveX;

const
  CLSID_SampleGrabber:        TGUID = '{C1F400A0-3F08-11D3-9F0B-006008039E37}';
  CLSID_CaptureGraphBuilder2: TGUID = (D1:$BF87B6E1;D2:$8C27;D3:$11d0;D4:($B3,$F0,$00,$AA,$00,$37,$61,$C5));
  IID_ICaptureGraphBuilder2:  TGUID = '{93E5A4E0-2D50-11d2-ABFA-00A0C9C6E38D}';
  IID_ISampleGrabberCB:       TGUID = '{0579154A-2B53-4994-B0D0-E773148EFF85}';
  IID_ISampleGrabber:         TGUID = '{6B652FFF-11FE-4FCE-92AD-0266B5D7C78F}';
  IID_ISpecifyPropertyPages:  TGUID = (
    D1:$B196B28B;D2:$BAB4;D3:$101A;D4:($B6,$9C,$00,$AA,$00,$34,$1D,$07));
  IID_IBasicAudio:            TGUID = (D1:$56A868B3;D2:$0AD4;D3:$11CE;D4:($B0,$3A,$00,$20,$AF,$0B,$A7,$70));

type

  TArrMoniker = array of IMoniker;

  FilterStatus = (Stopped,Paused,Running,StopRecord,
                  PauseRecord,StartRecord);

  PVideoStreamConfigCaps = ^TVideoStreamConfigCaps;
  _VIDEO_STREAM_CONFIG_CAPS = record
    guid: TGUID;
    VideoStandard      : ULONG;
    InputSize          : TSize;
    MinCroppingSize    : TSize;
    MaxCroppingSize    : TSize;
    CropGranularityX   : Integer;
    CropGranularityY   : Integer;
    CropAlignX         : Integer;
    CropAlignY         : Integer;
    MinOutputSize      : TSize;
    MaxOutputSize      : TSize;
    OutputGranularityX : Integer;
    OutputGranularityY : Integer;
    StretchTapsX       : Integer;
    StretchTapsY       : Integer;
    ShrinkTapsX        : Integer;
    ShrinkTapsY        : Integer;
    MinFrameInterval   : Int64;
    MaxFrameInterval   : Int64;
    MinBitsPerSecond   : Longint;
    MaxBitsPerSecond   : Longint;
  end;
  VIDEO_STREAM_CONFIG_CAPS = _VIDEO_STREAM_CONFIG_CAPS;
  TVideoStreamConfigCaps = _VIDEO_STREAM_CONFIG_CAPS;


  PAMMediaType = ^TAMMediaType;
  _AMMediaType = record
    majortype            : TGUID;
    subtype              : TGUID;
    bFixedSizeSamples    : BOOL;
    bTemporalCompression : BOOL;
    lSampleSize          : ULONG;
    formattype           : TGUID;
    pUnk                 : IUnknown;
    cbFormat             : ULONG;
    pbFormat             : Pointer;
  end;
  AM_MEDIA_TYPE = _AMMediaType;
  TAMMediaType = _AMMediaType;

type
  _PinDirection = (
    PINDIR_INPUT,
    PINDIR_OUTPUT
  );
  PIN_DIRECTION = _PinDirection;
  TPinDirection = PIN_DIRECTION;

  REFERENCE_TIME = LONGLONG;
  TReferenceTime = REFERENCE_TIME;
  PReferenceTime = ^TReferenceTime;

  IAMStreamConfig = interface(IUnknown)
    ['{C6E13340-30AC-11d0-A18C-00A0C9118956}']
    function SetFormat(const pmt: TAMMediaType): HResult; stdcall;
    function GetFormat(out ppmt: PAMMediaType): HResult; stdcall;
    function GetNumberOfCapabilities(out piCount, piSize: Integer): HResult; stdcall;
    function GetStreamCaps(iIndex: Integer; out ppmt: PAMMediaType;
      out pSCC): HResult; stdcall;
  end;

  ICaptureGraphBuilder2 = interface(IUnknown)
    ['{93E5A4E0-2D50-11d2-ABFA-00A0C9C6E38D}']
    function SetFiltergraph(pfg: IGraphBuilder): HResult; stdcall;
    function GetFiltergraph(out ppfg: IGraphBuilder): HResult; stdcall;
    function SetOutputFileName(const pType: TGUID; lpstrFile: PWCHAR; out ppf: IBaseFilter; out ppSink: IFileSinkFilter): HResult; stdcall;
    function FindInterface(pCategory, pType: PGUID; pf: IBaseFilter; const riid: TGUID; out ppint): HResult; stdcall;
    function RenderStream(pCategory, pType: PGUID; pSource: IUnknown; pfCompressor, pfRenderer: IBaseFilter): HResult; stdcall;
    function ControlStream(pCategory, pType: PGUID; pFilter: IBaseFilter; pstart, pstop: PReferenceTime; wStartCookie, wStopCookie: WORD ): HResult; stdcall;
    function AllocCapFile(lpstr: PWCHAR; dwlSize: int64): HResult; stdcall;
    function CopyCaptureFile(lpwstrOld, lpwstrNew: PWCHAR; fAllowEscAbort: Integer; pCallback: IAMCopyCaptureFileProgress): HResult; stdcall;
    function FindPin(pSource: IUnknown; pindir: TPINDIRECTION; const pCategory, pType: PGUID; fUnconnected: BOOL; num: integer; out ppPin: IPin): HResult; stdcall;
  end;

  IMediaPropertyBag = interface(IPropertyBag)
    ['{6025A880-C0D5-11D0-BD4E-00A0C911CE86}']
    function EnumProperty(iProperty: ULONG; var pvarPropertyName,
        pvarPropertyValue: OleVariant): HResult; stdcall;
  end;

  ISampleGrabberCB = interface(IUnknown)
    ['{0579154A-2B53-4994-B0D0-E773148EFF85}']
    function  SampleCB(SampleTime: Double; pSample: IMediaSample): HResult; stdcall;
    function  BufferCB(SampleTime: Double; pBuffer: PByte; BufferLen: longint): HResult; stdcall;
  end;

  ISampleGrabber = interface(IUnknown)
    ['{6B652FFF-11FE-4FCE-92AD-0266B5D7C78F}']
    function SetOneShot(OneShot: BOOL): HResult; stdcall;
    function SetMediaType(var pType: TAMMediaType): HResult; stdcall;
    function GetConnectedMediaType(out pType: TAMMediaType): HResult; stdcall;
    function SetBufferSamples(BufferThem: BOOL): HResult; stdcall;
    function GetCurrentBuffer(var pBufferSize: longint; pBuffer: Pointer): HResult; stdcall;
    function GetCurrentSample(out ppSample: IMediaSample): HResult; stdcall;
    function SetCallback(pCallback: ISampleGrabberCB; WhichMethodToCallback: longint): HResult; stdcall;
  end;

  INSSBuffer = interface(IUnknown)
    ['{E1CD3524-03D7-11d2-9EED-006097D2D7CF}']
    (*** INSSBuffer methods ***)
    function GetLength(out pdwLength: longword): HRESULT; stdcall;
    function SetLength(dwLength: longword): HRESULT; stdcall;
    function GetMaxLength(out pdwLength: longword): HRESULT; stdcall;
    function GetBuffer(out ppdwBuffer: PBYTE): HRESULT; stdcall;
    function GetBufferAndLength(out ppdwBuffer: PBYTE; out pdwLength: longword): HRESULT; stdcall;
  end;

  IBasicAudio = interface(IDispatch)
    ['{56A868B3-0AD4-11CE-B03A-0020AF0BA770}']
    (*** IBasicAudio methods ***)
    function put_Volume(lVolume: Longint): HResult; stdcall;
    function get_Volume(out plVolume: Longint): HResult; stdcall;
    function put_Balance(lBalance: Longint): HResult; stdcall;
    function get_Balance(out plBalance: Longint): HResult; stdcall;
  end;

type

 THIDSGrabber = class(TDebug)
   private
   { Var methods variable }
     {     }
     vVideoDevice: PStrList;
     {      }
     vAudioDevice: PStrList;
     {     }
     vVideoCodec: PStrList;
     {     }
     vAudioCodec: PStrList;

   { Property variable  }
     {     (avi) }
     FFileName: WideString;
     {      }
     fAudio: boolean;
     {       }
     fCodec: boolean;
     {  }
     fPause: boolean;
     {   }
     flog: boolean;
     {         }
     fSoundEchoOff: boolean;

     {     }
     FInputVideoIdx: integer;
     {     }
     FInputAudioIdx: integer;
     {     }
     FCodecVideoIdx: integer;
     {     }
     FCodecAudioIdx: integer;

     {   ,     
           }
     fMArray1, fMArray2,
     fMArray3, fMArray4: TArrMoniker;//array of IMoniker;

     //
     FGraphBuilder:        IGraphBuilder;
     FCaptureGraphBuilder: ICaptureGraphBuilder2;
     FMux:                 IBaseFilter;
     FSink:                IFileSinkFilter;
     FMediaControl:        IMediaControl;
     FVideoWindow:         IVideoWindow;

     FVideoCaptureFilter:  IBaseFilter;
     FAudioCaptureFilter:  IBaseFilter;
     FVideoCompressFilter: IBaseFilter;
     FAudioCompressFilter: IBaseFilter;
     //    
     FCompressVideoDialogs:IAMVfwCompressDialogs;
     //    
     FCompressAudioDialogs:ISpecifyPropertyPages;
     //  
     FBasicAudio:          IBasicAudio;

     //   
     FVideoHandle:         THandle;
     FVideoRect:           TRect;
     MainForm:             PControl;

     FBaseFilter:          IBaseFilter;
     FSampleGrabber:       ISampleGrabber;
     MediaType:            AM_MEDIA_TYPE;
     {     }
     FStatus:              FilterStatus;
     {    }
     FIndexVideo:          Integer;
   public
   { Event points }
     _event_onCaptureBitmap,
     _event_onVideoDeviceLst,
     _event_onAudioDeviceLst,
     _event_onVideoCodecLst,
     _event_onAudioCodecLst,
     _event_onError,
     _event_onLog: THI_Event;

   { Data points}
     {      }
     _data_VideoHandle: THI_Event;
     {     (avi) }
     _data_FileName: THI_Event;

     {    }
     _data_InputVideoIdx: THI_Event;
     {    }
     _data_InputAudioIdx: THI_Event;
     {    }
     _data_CodecVideoIdx: THI_Event;
     {    }
     _data_CodecAudioIdx: THI_Event;

   { Events }
     _data_Audio: THI_Event;
     _data_Codec: THI_Event;
     _data_Log: THI_Event;
     _data_SoundEchoOff: THI_Event;

     {     (avi) }
     _prop_FileName: WideString;
     {         }
     _prop_SoundEchoOff: boolean;

     constructor Create;
     destructor Destroy; override;

   { Methods }
     {   }
     procedure _work_doStart(var _Data: TData; Index: Word);
     {   }
     procedure _work_doStop(var _Data: TData; Index: Word);
     {   }
     procedure _work_doPause(var _Data: TData; Index: Word);
     {      }
     procedure _work_doResize(var _Data: TData; Index: Word);
     {    }
     procedure _work_doCaptureBitmap(var _Data: TData; Index: Word);
     {   Audio  Video   }
     procedure _work_doGetDevice(var _Data: TData; Index: Word);
     {       }
     procedure _work_doGetCodec(var _Data: TData; Index: Word);
     {      }
     procedure _work_doStartRecord(var _Data: TData; Index: Word);
     {      }
     procedure _work_doPauseRecord(var _Data: TData; Index: Word);
     {      }
     procedure _work_doStopRecord(var _Data: TData; Index: Word);
     {       }
     procedure _work_doPropertyCam(var _Data: TData; Index: Word);
     {      }
     procedure _work_doPropertyVideo(var _Data: TData; Index: Word);
     {      }
     procedure _work_doPropertyAudio(var _Data: TData; Index: Word);
     {      }
     procedure _work_doPropCodecVideo(var _Data: TData; Index: Word);
     {      }
     procedure _work_doPropCodecAudio(var _Data: TData; Index: Word);

   { Methods from property }
     {     (avi) }
     procedure _work_doFileName(var _Data: TData; Index: Word);

   { Var procedure }
     {     }
     procedure _var_VideoDevice(var _Data: TData; Index: Word);
     {      }
     procedure _var_AudioDevice(var _Data: TData; Index: Word);
     {    0-Stop,1-Pause,2-Run,
       3-StopRecord,4-PauseRecord,5-StartRecord }
     procedure _var_Status(var _Data: TData; Index: Word);
     {       }
     procedure _var_ScreenSizeDevice(var _Data: TData; Index: Word);
     {     }
     procedure _var_VideoCodec(var _Data: TData; Index: Word);
     {     }
     procedure _var_AudioCodec(var _Data: TData; Index: Word);

     {     }
     procedure _var_ActiveInputVideoIdx(var _Data: TData; Index: Word);
     {     }
     procedure _var_ActiveInputAudioIdx(var _Data: TData; Index: Word);
     {     }
     procedure _var_ActiveCodecVideoIdx(var _Data: TData; Index: Word);
     {     }
     procedure _var_ActiveCodecAudioIdx(var _Data: TData; Index: Word);

     {     }
     procedure _var_ActiveInputVideoName(var _Data: TData; Index: Word);
     {     }
     procedure _var_ActiveInputAudioName(var _Data: TData; Index: Word);
     {     }
     procedure _var_ActiveCodecVideoName(var _Data: TData; Index: Word);
     {     }
     procedure _var_ActiveCodecAudioName(var _Data: TData; Index: Word);

     function CreateGraph: HResult;
     function CaptureBitmap: HResult;
     procedure VisibleVideoCaptureFilter(idx: Integer; Handle: Integer);
     function DisplayPropertyFrame(Filter: IBaseFilter; Handle: THandle): HResult;
     {      }
     function DisplayPropertyVideoCodec(Filter: IBaseFilter; Handle: THandle): HResult;
     {      }
     function DisplayPropertyAudioCodec(Filter: IBaseFilter; Handle: THandle): HResult;
     {     }
     procedure OutErr(err: string);
     procedure OutLog(log: string);
     {     Web- }
     function GetScreenSizeDeviceLst: string;
     {      }
     function CheckInit: boolean;

   { Property }

     {      }
     property _prop_Audio: boolean  read fAudio  write fAudio;
     {       }
     property _prop_Codec: boolean  read fCodec  write fCodec;
     {     onLog }
     property _prop_Log: boolean  read fLog  write fLog;
  end;

implementation

var
  RecMode: Boolean = False; // 
  DeviceName: OleVariant;  // 
  PropertyName: IPropertyBag; //
  pDevEnum: ICreateDEvEnum; // 
  pEnum: IEnumMoniker; // 
  pMoniker: IMoniker;

constructor THIDSGrabber.Create;
begin
  inherited Create;
  vVideoDevice := NewStrList;
  vAudioDevice := NewStrList;
  vVideoCodec := NewStrList;
  vAudioCodec := NewStrList;
  FInputVideoIdx := -1;
  FInputAudioIdx := -1;
  FCodecVideoIdx := -1;
  FCodecAudioIdx := -1;
end;

destructor THIDSGrabber.Destroy;
begin
  vVideoDevice.Free;
  vAudioDevice.Free;
  vVideoCodec.Free;
  vAudioCodec.Free;
  inherited
end;

//   
procedure THIDSGrabber.OutErr(err: string);
begin
  _hi_onEvent(_event_onError, err + ';'
  + vVideoDevice.Items[FIndexVideo] + ';'
  + DateTime2StrShort(Now));
end;

procedure THIDSGrabber.OutLog(log: string);
begin
  if fLog = True then
  begin
  _hi_onEvent(_event_onLog, log + ';'
  + vVideoDevice.Items[FIndexVideo] + ';'
  + DateTime2StrShort(Now));
  end;
end;

{      }
function THIDSGrabber.CheckInit: boolean;
var
  dt: TData;
begin
  dtNull(dt);
  Result := False;
  FIndexVideo := ReadInteger(dt, _data_InputVideoIdx, -1);
  if FIndexVideo = -1 then
  begin
    _hi_onEvent(_event_onError,
      '!   '+'; ;'+DateTime2StrShort(Now));
    Exit;
  end;
  Result := True;
end;

//   GUID    
function GetInfoEx(CLSID: TGUID; var arrMon: TArrMoniker; var strLst: PStrList): string;
var
  hr: HRESULT;
begin
  strLst := NewStrList;
  DeviceName := '';
  //    
  hr := CoCreateInstance(CLSID_SystemDeviceEnum, NIL, CLSCTX_INPROC_SERVER,
          IID_ICreateDevEnum, pDevEnum);
  if hr <> S_OK then EXIT;
  // 
  hr := pDevEnum.CreateClassEnumerator(CLSID, pEnum, 0);
  if hr <> S_OK then EXIT;
  //    
  setlength(arrMon, 0);
  //    
  while (S_OK = pEnum.Next(1, pMoniker, Nil)) do
  begin
    //   
    setlength(arrMon, length(arrMon) + 1);
    //   
    arrMon[length(arrMon) - 1] := pMoniker;
    //      IPropertyBag
    hr := pMoniker.BindToStorage(NIL, NIL, IPropertyBag, PropertyName);
    if FAILED(hr) then Continue;
    //  
    hr := PropertyName.Read('FriendlyName', DeviceName, NIL);
    if FAILED(hr) then Continue;
    //    
    strLst.Add(string(DeviceName));
    Result := strLst.Text;
  end;
end;

function THIDSGrabber.CreateGraph: HResult;
var
  pConfigMux: IConfigAviMux;
  dt: TData;
  //FInputVideoIdx,FInputAudioIdx,FCodecVideoIdx,FCodecAudioIdx: integer;
begin
  if not CheckInit then Exit;
  // 
  FAudioCompressFilter := NIL;
  FVideoCompressFilter := NIL;
  FAudioCaptureFilter  := NIL;
  FVideoCaptureFilter  := NIL;
  FVideoWindow         := NIL;
  FMediaControl        := NIL;
  FSink                := NIL;
  FMux                 := NIL;
  FCaptureGraphBuilder := NIL;
  FGraphBuilder        := NIL;
  FSampleGrabber       := NIL;
  FCompressVideoDialogs:= NIL;
  FCompressAudioDialogs:= NIL;
  FBasicAudio          := NIL;

  FInputVideoIdx := -1;
  FInputAudioIdx := -1;
  FCodecVideoIdx := -1;
  FCodecAudioIdx := -1;

  //  
  Result := E_FAIL;
  dtNull(dt);
  FStatus              := Stopped;

  //   (   )
  FFileName := ReadString(dt,_data_FileName,_prop_FileName);
  FInputVideoIdx   := ReadInteger(dt,_data_InputVideoIdx,-1);
  FInputAudioIdx   := ReadInteger(dt,_data_InputAudioIdx,-1);
  FCodecVideoIdx   := ReadInteger(dt,_data_CodecVideoIdx,-1);
  FCodecAudioIdx   := ReadInteger(dt,_data_CodecAudioIdx,-1);
  fAudio := Boolean(ReadInteger(dt,_data_Audio,Integer(_prop_Audio)));
  fCodec := Boolean(ReadInteger(dt,_data_Codec,Integer(_prop_Codec)));
  fSoundEchoOff := Boolean(ReadInteger(dt,_data_SoundEchoOff,Integer(_prop_SoundEchoOff)));

  OutLog('  ');

  //      .
  FVideoHandle := ReadInteger(dt,_data_VideoHandle,0);
  if FVideoHandle = 0 then
  begin
    MainForm := NewForm(Applet,'Out video form');
    MainForm.Visible := True;
    MainForm.Width := 320;
    MainForm.Height := 240;
    MainForm.WindowState := wsMaximized;
    FVideoHandle := MainForm.Handle;
  end;

  //    
  Result := CoCreateInstance(CLSID_FilterGraph, NIL, CLSCTX_INPROC_SERVER, IID_IGraphBuilder, FGraphBuilder);
  if FAILED(Result) then EXIT;
  //    Audio
  Result :=FGraphBuilder.QueryInterface(IID_IBasicAudio, FBasicAudio);
  if FAILED(Result) then EXIT;
  //    
  Result:=CoCreateInstance(CLSID_SampleGrabber, NIL, CLSCTX_INPROC_SERVER, IID_IBaseFilter, FBaseFilter);
  if FAILED(Result) then EXIT;
  //    
  Result := CoCreateInstance(CLSID_CaptureGraphBuilder2, NIL, CLSCTX_INPROC_SERVER, IID_ICaptureGraphBuilder2, FCaptureGraphBuilder);
  if FAILED(Result) then EXIT;
  //    
  Result := FGraphBuilder.AddFilter(FBaseFilter, 'GRABBER');
  if FAILED(Result) then EXIT;
  //    
  Result := FBaseFilter.QueryInterface(IID_ISampleGrabber, FSampleGrabber);
  if FAILED(Result) then EXIT;

  if FSampleGrabber <> NIL then
  begin
    //      
    ZeroMemory(@MediaType, sizeof(AM_MEDIA_TYPE));

    with MediaType do
    begin
      majortype  := MEDIATYPE_Video;
      subtype    := MEDIASUBTYPE_RGB24;
      formattype := FORMAT_VideoInfo;
    end;

    FSampleGrabber.SetMediaType(MediaType);

    //        ,   
    //   
    FSampleGrabber.SetBufferSamples(TRUE);

    //       
    FSampleGrabber.SetOneShot(FALSE);
  end;

  //  
  Result := FCaptureGraphBuilder.SetFiltergraph(FGraphBuilder);
  if FAILED(Result) then EXIT;

  //  ListBox - 
  if FInputVideoIdx >= 0 then
  begin
    //       
    fMArray1[FInputVideoIdx].BindToObject(NIL, NIL, IID_IBaseFilter, FVideoCaptureFilter);
    //    
    FGraphBuilder.AddFilter(FVideoCaptureFilter, 'VideoCaptureFilter');
  end;

  //     
  if (FInputAudioIdx >= 0) and (fAudio = True) then
  begin
    OutLog('     - ' + vAudioDevice.Items[FInputAudioIdx]);
    //       
    fMArray2[FInputAudioIdx].BindToObject(NIL, NIL, IID_IBaseFilter, FAudioCaptureFilter);
    //    
    FGraphBuilder.AddFilter(FAudioCaptureFilter, 'AudioCaptureFilter');
    //    
    Result := FCaptureGraphBuilder.RenderStream(@PIN_CATEGORY_PREVIEW, @MEDIATYPE_Audio,
                FAudioCaptureFilter, NIL, NIL);
    if FAILED(Result) then EXIT;
  end else OutLog('     ');

  //    
  if fCodec = True then
  begin
    if FCodecVideoIdx >= 0 then
      begin
        fMArray3[FCodecVideoIdx].BindToObject(NIL, NIL, IID_IBaseFilter, FVideoCompressFilter);
        FGraphBuilder.AddFilter(FVideoCompressFilter, 'VideoCompressFilter');
        OutLog('     - '+ vVideoCodec.Items[FCodecVideoIdx]);
      end else OutLog('     ');
    if FCodecAudioIdx >= 0 then
      begin
        fMArray4[FCodecAudioIdx].BindToObject(NIL, NIL, IID_IBaseFilter, FAudioCompressFilter);
        FGraphBuilder.AddFilter(FAudioCompressFilter, 'AudioCompressFilter');
        OutLog('     - ' + vAudioCodec.Items[FCodecAudioIdx]);
      end else OutLog('     ');
  end;

  //    
  //Result := FCaptureGraphBuilder.RenderStream(@PIN_CATEGORY_PREVIEW, @MEDIATYPE_Video, FVideoCaptureFilter, NIL, NIL);
  //if FAILED(Result) then EXIT;

  //,         
  Result := FCaptureGraphBuilder.RenderStream(@PIN_CATEGORY_PREVIEW, nil, FVideoCaptureFilter, FBaseFilter, nil);
  if FAILED(Result) then EXIT;

  //    
  Result := FGraphBuilder.QueryInterface(IID_IVideoWindow, FVideoWindow);
  if FAILED(Result) then EXIT;
  //   
  FVideoWindow.put_WindowStyle(WS_CHILD or WS_CLIPSIBLINGS);
  //     Panel1
  FVideoWindow.put_Owner(FVideoHandle);
  //     
  GetWindowRect(FVideoHandle, FVideoRect);
  FVideoWindow.SetWindowPosition(0, 0, FVideoRect.Right - FVideoRect.Left, FVideoRect.Bottom - FVideoRect.Top);
  // 
  FVideoWindow.put_Visible(TRUE);

  // avi
  if RecMode then
  begin
  //      
  Result:=FCaptureGraphBuilder.SetOutputFileName(MEDIASUBTYPE_Avi, PWideChar(FFileName), FMux, FSink);
  if FAILED(Result) then EXIT;

  //     
  Result:=FCaptureGraphBuilder.RenderStream(@PIN_CATEGORY_CAPTURE, @MEDIATYPE_Video, FVideoCaptureFilter, FVideoCompressFilter, FMux);
  if FAILED(Result) then EXIT;

  if (FInputAudioIdx >= 0) and (fAudio = True) then
    begin
      //     
      Result:=FCaptureGraphBuilder.RenderStream(@PIN_CATEGORY_CAPTURE, @MEDIATYPE_Audio, FAudioCaptureFilter, FAudioCompressFilter, FMux);
      if FAILED(Result) then EXIT;
      //         
      //         
      pConfigMux := NIL;
      Result:=FMux.QueryInterface(IID_IConfigAviMux, pConfigMux);
      if FAILED(Result) then EXIT;

      pConfigMux.SetMasterStream(1);
      pConfigMux := NIL;
    end;
  end;

  //   
  Result:=FGraphBuilder.QueryInterface(IID_IMediaControl, FMediaControl);
  if FAILED(Result) then Exit;
  //    
  FMediaControl.Run();
  if fSoundEchoOff then  //  
  begin
     OutLog(' "" SoundEchoOff = True');
     FBasicAudio.put_Volume(-10000);
  end else FBasicAudio.put_Volume(0);
end;

{   }
procedure THIDSGrabber._work_doStart;
begin
  if not CheckInit then Exit;
  fLog := Boolean(ReadInteger(_Data,_data_Log,Integer(_prop_Log)));
  //    
  if FAILED(CreateGraph) then
    begin
      OutErr('!        doStart');
      RecMode := False;
      Exit;
    end else begin
      OutLog('  ');
      FStatus := Running;
    end;
end;

{   }
procedure THIDSGrabber._work_doStop;
begin
  if not CheckInit then Exit;
  // 
  FAudioCompressFilter := NIL;
  FVideoCompressFilter := NIL;
  FAudioCaptureFilter  := NIL;
  FVideoCaptureFilter  := NIL;
  FVideoWindow         := NIL;
  FMediaControl        := NIL;
  FSink                := NIL;
  FMux                 := NIL;
  FCaptureGraphBuilder := NIL;
  FGraphBuilder        := NIL;
  FSampleGrabber       := NIL;
  FCompressVideoDialogs:= NIL;
  FCompressAudioDialogs:= NIL;
  FBasicAudio          := NIL;
  OutLog('  ');
  FInputVideoIdx := -1;
  FInputAudioIdx := -1;
  FCodecVideoIdx := -1;
  FCodecAudioIdx := -1;
  OutLog(' ');
  FStatus := Stopped;
end;

{   }
procedure THIDSGrabber._work_doPause;
begin
  if not CheckInit then Exit;
  if FStatus = Stopped then exit;
  fPause := not fPause;
  if fPause then
    begin
      FMediaControl.Pause();
      OutLog('  (-)');
      FStatus := Paused;
    end
  else
    begin
      OutLog('   ');
      FMediaControl.Run();
      FStatus := Running;
    end;
end;

{      }
procedure THIDSGrabber._work_doResize;
begin
  if not CheckInit then Exit;
  if FVideoHandle = 0 then exit;
    GetWindowRect(FVideoHandle, FVideoRect);
    FVideoWindow.SetWindowPosition(0, 0, FVideoRect.Right - FVideoRect.Left, FVideoRect.Bottom - FVideoRect.Top);
end;

{    }
procedure THIDSGrabber._work_doCaptureBitmap;
begin
  if not CheckInit then Exit;
  if CaptureBitmap = E_FAIL then
    OutErr('!  ,    ')
  else
    OutLog('  ');
end;

{        }
procedure THIDSGrabber._work_doGetDevice;
begin
  //FInputVideoIdx := -1;
  //FInputAudioIdx := -1;
  _hi_onEvent(_event_onVideoDeviceLst,
    GetInfoEx(CLSID_VideoInputDeviceCategory,fMArray1,vVideoDevice));
  _hi_onEvent(_event_onAudioDeviceLst,
    GetInfoEx(CLSID_AudioInputDeviceCategory,fMArray2,vAudioDevice));
end;

{        }
procedure THIDSGrabber._work_doGetCodec;
begin
  //FCodecVideoIdx := -1;
  //FCodecAudioIdx := -1;
  _hi_onEvent(_event_onVideoCodecLst,
    GetInfoEx(CLSID_VideoCompressorCategory,fMArray3,vVideoCodec));
  _hi_onEvent(_event_onAudioCodecLst,
    GetInfoEx(CLSID_AudioCompressorCategory,fMArray4,vAudioCodec));
end;

{     (avi) }
procedure THIDSGrabber._work_doFileName;
begin
  FFileName := '';
  _prop_FileName := ToString(_Data);
end;

{     }
procedure THIDSGrabber._var_VideoDevice;
begin
  GetInfoEx(CLSID_VideoInputDeviceCategory,fMArray1,vVideoDevice);
  dtString(_Data, vVideoDevice.Text);
end;

{      }
procedure THIDSGrabber._var_AudioDevice;
begin
  GetInfoEx(CLSID_AudioInputDeviceCategory,fMArray2,vAudioDevice);
  dtString(_Data, vAudioDevice.Text);
end;

{     }
procedure THIDSGrabber._var_VideoCodec;
begin
  GetInfoEx(CLSID_VideoCompressorCategory,fMArray3,vVideoCodec);
  dtString(_Data,vVideoCodec.Text);
end;

{     }
procedure THIDSGrabber._var_AudioCodec;
begin
  GetInfoEx(CLSID_AudioCompressorCategory,fMArray4,vAudioCodec);
  dtString(_Data,vAudioCodec.Text);
end;

{    0-Stop,1-Pause,2-Run,
  3-StopRecord,4-PauseRecord,5-StartRecord }
procedure THIDSGrabber._var_Status;
begin
  dtInteger(_Data, Integer(FStatus));
end;

{       }
procedure THIDSGrabber._var_ScreenSizeDevice;
begin
  dtString(_Data, GetScreenSizeDeviceLst);
end;

{      }
procedure THIDSGrabber._work_doStartRecord;
begin
  if not CheckInit then Exit;
  fLog := Boolean(ReadInteger(_Data,_data_Log,Integer(_prop_Log)));
  if RecMode then Exit;
  RecMode := True;
  //    
  if FAILED(CreateGraph) then
    begin
      OutErr('!        doStartRecord');
      RecMode := False;
      Exit;
    end else begin
      OutLog('   ' + ExtractFileName(FFileName));
      FStatus := StartRecord;
    end;
end;

{      }
procedure THIDSGrabber._work_doPauseRecord;
begin
  if not CheckInit then Exit;
  fPause := not fPause;
  if fPause then begin
    FMediaControl.Pause();
    OutLog('    ' + ExtractFileName(FFileName));
    FStatus := PauseRecord;
  end else begin
    FMediaControl.Run();
    OutLog('    ' + ExtractFileName(FFileName));
    FStatus := StartRecord;
  end;
end;

{      }
procedure THIDSGrabber._work_doStopRecord;
begin
  if not CheckInit then Exit;
  //   ,  
  if not(RecMode) then Exit;
  //  
  FMediaControl.Stop;
  //  
  RecMode:=False;
  // 
  if FAILED(CreateGraph) then
    begin
      OutErr('!      ');
      Exit;
    end else begin
      OutLog('    ' + ExtractFileName(FFileName));
      FStatus := StopRecord;
    end;
end;

{       }
procedure THIDSGrabber._work_doPropertyCam;
begin
  if not CheckInit then Exit;
  VisibleVideoCaptureFilter(FIndexVideo, ReadHandle);
  OutLog('     ');
end;

{      }
procedure THIDSGrabber._work_doPropertyVideo;
begin
  if not CheckInit then Exit;
  if RecMode then
  begin
    OutErr('!  ,      ');
    Exit;
  end else begin
    DisplayPropertyFrame(FVideoCaptureFilter, ReadHandle);
    OutLog('    ');
  end;
end;

{      }
procedure THIDSGrabber._work_doPropertyAudio;
begin
  if not CheckInit then Exit;
  if RecMode then Exit;
  DisplayPropertyFrame(FAudioCaptureFilter, ReadHandle);
end;

{      }
procedure THIDSGrabber._work_doPropCodecVideo;
begin
  if not CheckInit then Exit;
  if RecMode then Exit;
  if Failed(DisplayPropertyFrame(FVideoCompressFilter, ReadHandle)) then
    DisplayPropertyVideoCodec(FVideoCompressFilter, ReadHandle);
end;
{      }
procedure THIDSGrabber._work_doPropCodecAudio;
begin
  if not CheckInit then Exit;
  if RecMode then Exit;
  DisplayPropertyAudioCodec(FAudioCompressFilter, ReadHandle);
end;

//      
function THIDSGrabber.CaptureBitmap: HResult;
var
  bSize: integer;
  pVideoHeader: TVideoInfoHeader;
  MediaType: TAMMediaType;
  BitmapInfo: TBitmapInfo;
  Buffer: Pointer;
  tmp: array of byte;
  Bitmap: PBitmap;
begin
  //   
  Result := E_FAIL;

  //       ,
  //   
  if FSampleGrabber = NIL then EXIT;

  //   
  Result := FSampleGrabber.GetCurrentBuffer(bSize, NIL);
  if (bSize <= 0) or FAILED(Result) then EXIT;

  //  
  Bitmap := NewBitmap(0,0);
  try
  // 
  ZeroMemory(@MediaType, sizeof(TAMMediaType));
  //         
  Result := FSampleGrabber.GetConnectedMediaType(MediaType);
  if FAILED(Result) then EXIT;

    //   
    pVideoHeader := TVideoInfoHeader(MediaType.pbFormat^);
    ZeroMemory(@BitmapInfo, sizeof(TBitmapInfo));
    CopyMemory(@BitmapInfo.bmiHeader, @pVideoHeader.bmiHeader, sizeof(TBITMAPINFOHEADER));

    Buffer := NIL;

    //   
    Bitmap.Handle := CreateDIBSection(0, BitmapInfo, DIB_RGB_COLORS, Buffer, 0, 0);

    //     
    SetLength(tmp, bSize);

    try
      //        
      FSampleGrabber.GetCurrentBuffer(bSize, @tmp[0]);

      //        
      CopyMemory(Buffer, @tmp[0], MediaType.lSampleSize);

      //     bmp 
      //Bitmap.SaveToFile(' .bmp');
      _hi_onEvent(_event_onCaptureBitmap, Bitmap);
    except

      //      
      Result := E_FAIL;
    end;
  finally
    //  
    SetLength(tmp, 0);
    Bitmap.Free;
  end;
end;

//   Web-
procedure THIDSGrabber.VisibleVideoCaptureFilter(idx: Integer; Handle: Integer);
var
  StreamConfig: IAMStreamConfig;
  PropertyPages: ISpecifyPropertyPages;
  Pages: CAUUID;
  Name: WideString;
begin
if not CheckInit then Exit;
Name := vVideoDevice.Items[idx];
//    - 
If RecMode then Exit;
  //      ,   
  if FVideoCaptureFilter = NIL then EXIT;
  //   
  //FMediaControl.Stop;
  try
    //       
    //   ,  ...
    if SUCCEEDED(FCaptureGraphBuilder.FindInterface(@PIN_CATEGORY_CAPTURE,
      @MEDIATYPE_Video, FVideoCaptureFilter, IID_IAMStreamConfig, StreamConfig)) then
    begin
      // ...       ...
      // ... ,   ,  ...
      if SUCCEEDED(StreamConfig.QueryInterface(ISpecifyPropertyPages, PropertyPages)) then
      begin
        // ...    
        PropertyPages.GetPages(Pages);
        PropertyPages := NIL;

        //       
        OleCreatePropertyFrame(
           Handle,
           0,
           0,
           PWideChar(Name),
           1,
           @StreamConfig,
           Pages.cElems,
           Pages.pElems,
           0,
           0,
           NIL
        );

        //  
        StreamConfig := NIL;
        CoTaskMemFree(Pages.pElems);
      end;
    end;

  finally
    //   
    //FMediaControl.Run;
  end;
end;

//    
function THIDSGrabber.DisplayPropertyFrame(Filter: IBaseFilter; Handle: THandle): HResult;
var
  PropertyPages: ISpecifyPropertyPages;
  Pages: CAUUID;
  FilterInfo: TFilterInfo;
  pfilterUnk: IUnknown;
begin
  if not CheckInit then Exit;
  //   
  Result := E_FAIL;

  //    ,   
  if Filter = NIL then EXIT;

  //       
  Result := Filter.QueryInterface(ISpecifyPropertyPages, PropertyPages);

  if (SUCCEEDED(Result)) then
  begin
    //        IUnknown
    Filter.QueryFilterInfo(FilterInfo);
    Filter.QueryInterface(IUnknown, pfilterUnk);

    //    
    PropertyPages.GetPages(Pages);
    PropertyPages := NIL;

    //       
    OleCreatePropertyFrame(
       Handle,
       0,
       0,
       FilterInfo.achName,
       1,
       @pfilterUnk,
       Pages.cElems,
       Pages.pElems,
       0,
       0,
       NIL
    );

    //  
    pfilterUnk := NIL;
    FilterInfo.pGraph := NIL;
    CoTaskMemFree(Pages.pElems);
  end;

end;

//   
function THIDSGrabber.DisplayPropertyVideoCodec(Filter: IBaseFilter; Handle: THandle): HResult;
begin
  if not CheckInit then Exit;
  if not assigned(Filter) then exit;
  //if Filter = NIL then EXIT;
  if Assigned(FCaptureGraphBuilder) then
  begin
    Result := FCaptureGraphBuilder.FindInterface( @PIN_CATEGORY_CAPTURE, @MEDIATYPE_Video,
                               Filter, IID_IAMVfwCompressDialogs, FCompressVideoDialogs);

    Result := FCompressVideoDialogs.ShowDialog(1, Handle)
  end;
end;

//    
function THIDSGrabber.DisplayPropertyAudioCodec(Filter: IBaseFilter; Handle: THandle): HResult;
var
  auuid: CAUUID;
  FilterInfo: TFilterInfo;
begin
  if not CheckInit then Exit;
  if not assigned(Filter) then exit;
  if Filter.QueryInterface(IID_ISpecifyPropertyPages, FCompressAudioDialogs)=S_OK then
  begin
    Filter.QueryFilterInfo(FilterInfo);
    FCompressAudioDialogs.GetPages(auuid);
    OleCreatePropertyFrame(Handle, 0, 0, FilterInfo.achName, 1, @Filter, auuid.cElems, auuid.pElems, 0, 0, nil);
    CoTaskMemFree(auuid.pElems);
    FilterInfo.pGraph := NIL;
  end;
end;

//    Web-
function THIDSGrabber.GetScreenSizeDeviceLst: string;
var
  StreamConfig: IAMStreamConfig;
  capCount,CapSize: integer;
  pmt: PAMMEDIATYPE;
  scc: VIDEO_STREAM_CONFIG_CAPS;
  W,H: Integer;
  i,j: Integer;
  tmpLst: PStrList;
begin
  if not CheckInit then Exit;
  tmpLst := NewStrList;
  //      ,   
  if FVideoCaptureFilter = NIL then EXIT;
  //   
  // FMediaControl.Stop; //   ...
  try
    //       
    //   ,  ...
    if SUCCEEDED(FCaptureGraphBuilder.FindInterface(@PIN_CATEGORY_CAPTURE,
      @MEDIATYPE_Video, FVideoCaptureFilter, IID_IAMStreamConfig, StreamConfig)) then
      //   
       StreamConfig.GetNumberOfCapabilities(CapCount,CapSize);
    for i := 0 to Round((CapCount-1)/2) do  //   ,   !!!!
     begin
       j := i*2;
       //   AM_MEDIA_TYPE  VIDEO_STREAM_CONFIG_CAPS
       StreamConfig.GetStreamCaps(j,pmt,scc);
       W := scc.InputSize.cx;
       H := scc.InputSize.cy;
       tmpLst.Add('[' + Int2Str(w) + 'x' + Int2Str(h) + ']');
     end;
        //  
        StreamConfig := NIL;
  finally
    //   
    //FMediaControl.Run;
  end;
  Result := tmpLst.Text;
  tmpLst.Free;
end;


{     }
procedure THIDSGrabber._var_ActiveInputVideoIdx;
begin
  dtInteger(_Data,FInputVideoIdx);
end;

{     }
procedure THIDSGrabber._var_ActiveInputAudioIdx;
begin
  if fCodec then
    dtInteger(_Data,FInputAudioIdx)
  else dtInteger(_Data,-1);
end;


{     }
procedure THIDSGrabber._var_ActiveCodecVideoIdx;
begin
  if fCodec then
    dtInteger(_Data,FCodecVideoIdx)
  else dtInteger(_Data,-1);
end;


{     }
procedure THIDSGrabber._var_ActiveCodecAudioIdx;
begin
  dtInteger(_Data,FCodecAudioIdx);
end;


{     }
procedure THIDSGrabber._var_ActiveInputVideoName;
begin
  dtString(_Data, vVideoDevice.Items[FInputVideoIdx]);
end;


{     }
procedure THIDSGrabber._var_ActiveInputAudioName;
begin
  dtString(_Data, vAudioDevice.Items[FInputAudioIdx]);
end;


{     }
procedure THIDSGrabber._var_ActiveCodecVideoName;
begin
  if fCodec then
    dtString(_Data,vVideoCodec.Items[FCodecVideoIdx]);
end;


{     }
procedure THIDSGrabber._var_ActiveCodecAudioName;
begin
  if fCodec then
    dtString(_Data,vAudioCodec.Items[FCodecAudioIdx]);
end;


initialization
  CoInitialize(nil); //  OLE COM

finalization


end.
